VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cColor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Enum ColorSpace
    ColorRGB
    ColorCMYK
    ColorHSL
End Enum

Private Type TCHOOSECOLOR
    lStructSize     As Long
    hWndOwner       As Long
    hInstance       As Long
    rgbResult       As Long
    lpCustColors    As Long
    Flags           As Long
    lCustData       As Long
    lpfnHook        As Long
    lpTemplateName  As Long
End Type

Private Declare Function ChooseColor Lib "COMDLG32.DLL" Alias "ChooseColorA" (Color As TCHOOSECOLOR) As Long

Private CustomColors(0 To 15) As Long

Private m_Value     As Long
Private m_color     As ColorSpace

Private m_Red       As Byte
Private m_Green     As Byte
Private m_Blue      As Byte

Private m_C         As Double
Private m_M         As Double
Private m_Y         As Double
Private m_K         As Double

Private m_H         As Double
Private m_S         As Double
Private m_L         As Double

Private converted(ColorRGB To ColorHSL) As Boolean
'

Public Sub RGB(ByVal Red As Byte, ByVal Green As Byte, ByVal Blue As Byte)
    
    m_Red = Red
    m_Green = Green
    m_Blue = Blue
    
    m_Value = Information.RGB(m_Red, m_Green, m_Blue)
    
    m_color = ColorRGB
    
    Reset
    
End Sub
'

Public Sub CMYK(ByVal Cyan As Long, ByVal Magenta As Long, ByVal Yellow As Long, ByVal Black As Long)
    
    Cyan = IIf(Cyan < 0, 0, IIf(Cyan > 100, 100, Cyan))
    Magenta = IIf(Magenta < 0, 0, IIf(Magenta > 100, 100, Magenta))
    Yellow = IIf(Yellow < 0, 0, IIf(Yellow > 100, 100, Yellow))
    Black = IIf(Black < 0, 0, IIf(Black > 100, 100, Black))
    
    m_C = Cyan / 100
    m_M = Magenta / 100
    m_Y = Yellow / 100
    m_K = Black / 100
    
    m_color = ColorCMYK
    
    Reset
    
End Sub
'

Public Sub HSL(ByVal Hue As Long, ByVal Satutiration As Long, ByVal Lightness As Long)
    
    Hue = IIf(Hue < 0, 0, IIf(Hue > 240, 240, Hue))
    Satutiration = IIf(Satutiration < 0, 0, IIf(Satutiration > 240, 240, Satutiration))
    Lightness = IIf(Lightness < 0, 0, IIf(Lightness > 240, 240, Lightness))
    
    m_H = Hue / 240
    m_S = Satutiration / 240
    m_L = Lightness / 240
    
    m_color = ColorHSL
    
    Reset
    
End Sub
'

Public Function PickColor(hWndParent As Long, Optional DefaultColor As Long, Optional ShowExpDlg As Boolean = True) As Boolean
    
    
    Dim C As Long
    Dim CC As TCHOOSECOLOR
        
    With CC
         
        .rgbResult = DefaultColor
        .hWndOwner = hWndParent
        .lpCustColors = VarPtr(CustomColors(0))
        .Flags = &H101
         
        If ShowExpDlg Then .Flags = .Flags Or &H2
         
        .lStructSize = Len(CC)
        C = ChooseColor(CC)
         
        If C Then
           Me.Value = .rgbResult
           PickColor = True
        Else
           PickColor = False
        End If
         
    End With

End Function
'

Public Property Get Red() As Byte
    
    ConvertTo ColorRGB
    
    Red = m_Red
    
End Property
'

Public Property Get Green() As Byte
    
    ConvertTo ColorRGB
    
    Green = m_Green
    
End Property
'

Public Property Get Blue() As Byte
    
    ConvertTo ColorRGB
    
    Blue = m_Blue
    
End Property
'

Public Property Get Cyan() As Long
    
    ConvertTo ColorCMYK
    
    Cyan = m_C * 100
    
End Property
'

Public Property Get Magenta() As Long
    
    ConvertTo ColorCMYK
    
    Magenta = m_M * 100
    
End Property
'

Public Property Get Yellow() As Long
    
    ConvertTo ColorCMYK
    
    Yellow = m_Y * 100
    
End Property
'

Public Property Get Key() As Long
    
    ConvertTo ColorCMYK
    
    Key = m_K * 100
    
End Property
'

Public Property Get Hue() As Long
    
    ConvertTo ColorHSL
    
    Hue = m_H * 240
    
End Property
'

Public Property Get Satituration() As Long
    
    ConvertTo ColorHSL
    
    Satituration = m_S * 240
    
End Property
'

Public Property Get Lightness() As Long
    
    ConvertTo ColorHSL
    
    Lightness = m_L * 240
    
End Property
'

Public Property Get Value() As Long
    
    ConvertTo ColorRGB
    
    Value = m_Value
    
End Property
'

Public Property Let Value(l As Long)
    
    m_Value = l
    
    m_Red = l Mod 256
    m_Green = (l \ &H100) Mod 256
    m_Blue = (l \ &H10000) Mod 256
    
    m_color = ColorRGB
    
    Reset

End Property
'

Public Property Get CustomColor(Index As Long) As Long
    
    CustomColor = CustomColors(Index)
    
End Property
'

Public Property Let CustomColor(Index As Long, Value As Long)
    
    CustomColors(Index) = Value
    
End Property
'

Private Sub Reset()
    
    converted(ColorRGB) = (m_color = ColorRGB)
    converted(ColorCMYK) = (m_color = ColorCMYK)
    converted(ColorHSL) = (m_color = ColorHSL)
    
End Sub
'

Private Sub ConvertTo(Color As ColorSpace)
    
    If converted(Color) Then Exit Sub
    
    Dim var_Red     As Double
    Dim var_Green   As Double
    Dim var_Blue    As Double
    Dim var_Min     As Double
    Dim var_Max     As Double
    Dim var_Delta   As Double
    Dim del_Red     As Double
    Dim del_Green   As Double
    Dim del_Blue    As Double
    Dim var1        As Double
    Dim var2        As Double
    
    ' RGB -> HSL
    If converted(ColorRGB) And Color = ColorHSL Then
        
        var_Red = m_Red / 255
        var_Green = m_Green / 255
        var_Blue = m_Blue / 255
        
        var_Min = min(var_Red, var_Green, var_Blue)
        var_Max = max(var_Red, var_Green, var_Blue)
        var_Delta = var_Max - var_Min
        
        m_L = (var_Max + var_Min) / 2
        
        If var_Delta = 0 Then
            
            m_H = 0
            m_S = 0
        
        Else
            
            If m_L < 0.5 Then
                m_S = var_Delta / (var_Max + var_Min)
            Else
                m_S = var_Delta / (2 - var_Max - var_Min)
            End If
            
            del_Red = (((var_Max - var_Red) / 6) + (var_Delta / 2)) / var_Delta
            del_Green = (((var_Max - var_Green) / 6) + (var_Delta / 2)) / var_Delta
            del_Blue = (((var_Max - var_Blue) / 6) + (var_Delta / 2)) / var_Delta
                
            Select Case var_Max
                Case var_Red:      m_H = del_Blue - del_Green
                Case var_Green:    m_H = (1 / 3) + del_Red - del_Blue
                Case var_Blue:     m_H = (2 / 3) + del_Green - del_Red
            End Select
            
            If m_H < 0 Then m_H = m_H + 1
            If m_H > 1 Then m_H = m_H - 1
        
        End If
    
    ' HSL -> RGB
    ElseIf converted(ColorHSL) And Color = ColorRGB Then
        
        If m_S = 0 Then
            
            m_Red = m_L * 255
            m_Green = m_L * 255
            m_Blue = m_L * 255
            
        Else
            
            If m_L < 0.5 Then
                var2 = m_L * (1 + m_S)
            Else
                var2 = (m_L + m_S) - (m_S * m_L)
            End If
            
            var1 = 2 * m_L - var2
            
            m_Red = 255 * HueToRGB(var1, var2, m_H + (1 / 3))
            m_Green = 255 * HueToRGB(var1, var2, m_H)
            m_Blue = 255 * HueToRGB(var1, var2, m_H - (1 / 3))
        
        End If
        
        m_Value = Information.RGB(m_Red, m_Green, m_Blue)
    
    
    ' RGB -> CMYK
    ElseIf converted(ColorRGB) And Color = ColorCMYK Then
    
        m_C = 1 - (m_Red / 255)
        m_M = 1 - (m_Green / 255)
        m_Y = 1 - (m_Blue / 255)
        
        var1 = 1
        
        If m_C < var1 Then var1 = m_C
        If m_M < var1 Then var1 = m_M
        If m_Y < var1 Then var1 = m_Y
        
        If var1 = 1 Then
            m_C = 0
            m_M = 0
            m_Y = 0
        Else
            m_C = (m_C - var1) / (1 - var1)
            m_M = (m_M - var1) / (1 - var1)
            m_Y = (m_Y - var1) / (1 - var1)
        End If
        
        m_K = var1
    
    
    ' CMYK -> RGB
    ElseIf converted(ColorRGB) And Color = ColorCMYK Then
            
            m_Red = (1 - (m_C * (1 - m_K) + m_K)) * 255
            m_Green = (1 - (m_M * (1 - m_K) + m_K)) * 255
            m_Blue = (1 - (m_Y * (1 - m_K) + m_K)) * 255
            
            m_Value = Information.RGB(m_Red, m_Green, m_Blue)
    
    
    ' HSL -> CMYK
    ElseIf converted(ColorHSL) And Color = ColorCMYK Then
        
        ConvertTo ColorRGB
        ConvertTo ColorCMYK
    
    
    ' CMYK -> HSL
    ElseIf converted(ColorCMYK) And Color = ColorHSL Then
        
        ConvertTo ColorRGB
        ConvertTo ColorHSL
    
    End If
    
        
    converted(Color) = True

End Sub
'

Private Function min(ParamArray items()) As Double
    
    Dim i   As Long
    Dim ret As Double
    
    For i = LBound(items) To UBound(items)
        If items(i) < ret Then ret = items(i)
    Next
    
    min = ret
    
End Function
'

Private Function max(ParamArray items()) As Double
    
    Dim i   As Long
    Dim ret As Double
    
    For i = LBound(items) To UBound(items)
        If items(i) > ret Then ret = items(i)
    Next
    
    max = ret
    
End Function
'

Private Function HueToRGB(v1 As Double, v2 As Double, vH As Double) As Double
    
    Dim ret As Double
    
    If vH < 0 Then vH = vH + 1
    If vH > 1 Then vH = vH - 1
    
    ret = v1
    
    If (6 * vH) < 1 Then
        ret = v1 + (v2 - v1) * 6 * vH
    ElseIf (2 * vH) < 1 Then
        ret = v2
    ElseIf (3 * vH) < 2 Then
        ret = v1 + (v2 - v1) * ((2 / 3) - vH) * 6
    End If
    
    HueToRGB = ret
    
End Function
'

Private Sub Class_Initialize()
        
    Dim i   As Long
    
    For i = 0 To 15
        CustomColors(i) = QBColor(i)
    Next
   
End Sub
